package kayttoliittyma;

import javax.swing.JOptionPane;

public class Kayttoliittyma {
    private Gui gui;
    private static boolean created;

    public Kayttoliittyma(final Object sokkelopeli) {
        if (created) {
            throw new IllegalStateException("Voit luoda vain yhden Kayttoliittyma-olion");
        }
        created = true;
        swingInvokeAndWait(new Runnable() {
            public void run() {
                gui = new Gui(new SokkelopeliProxy(sokkelopeli));
            }
        });
    }

    public void naytaViesti(final String viesti) {
        swingInvokeAndWait(new Runnable() {
            public void run() {
                JOptionPane.showMessageDialog(gui, viesti);
            }
        });
    }

    public void lopetaOhjelma() {
        System.exit(0);
    }

    private void swingInvokeAndWait(Runnable runnable) {
        try {
            javax.swing.SwingUtilities.invokeAndWait(runnable);
        } catch (Exception ex) {
            throw new RuntimeException(ex);
        }
    }
}
