package kayttoliittyma;

import peli.Paikka;

public class SokkelopeliProxy extends Proxy<SokkelopelinRajapinta> implements SokkelopelinRajapinta {

    public SokkelopeliProxy(Object target) {
        super(target);
    }
    
    @Override
    public int sokkelonLeveys() {
        String m = "sokkelonLeveys";
        return checkPositive(m, callMethod(Integer.TYPE, m));
    }

    @Override
    public int sokkelonKorkeus() {
        String m = "sokkelonKorkeus";
        return checkPositive(m, callMethod(Integer.TYPE, m));
    }

    @Override
    public String kuvaPaikassa(Paikka paikka) {
        String m = "kuvaPaikassa";
        return checkNotNull(m, callMethod(String.class, m, paikka));
    }

    @Override
    public boolean yritaVasemmalle() {
        return callMethod(Boolean.TYPE, "yritaVasemmalle");
    }

    @Override
    public boolean yritaOikealle() {
        return callMethod(Boolean.TYPE, "yritaOikealle");
    }

    @Override
    public boolean yritaYlos() {
        return callMethod(Boolean.TYPE, "yritaYlos");
    }

    @Override
    public boolean yritaAlas() {
        return callMethod(Boolean.TYPE, "yritaAlas");
    }

    private <T> T checkNotNull(String methodName, T obj) {
        if (obj != null) {
            return obj;
        } else {
            throw new ProxyException(
                "Metodi '" + methodName +
                "' palautti null-arvon. Ei näin.");
        }
    }

    private int checkPositive(String m, int result) {
        if (result <= 0) {
            throw new ProxyException(
                "Metodi '" + m + "' palautti " + result +
                ", mutta arvon pitäisi olla positiivinen.");
        }
        return result;
    }
    
}
