/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package kayttoliittyma;

import peli.Paikka;
import org.junit.Before;
import org.junit.Test;

import static org.mockito.Mockito.*;

public class SokkelopeliProxyTest {

    private SokkelopelinRajapinta target;

    private SokkelopeliProxy proxy;
    
    @Before
    public void setUp() {
        target = mock(SokkelopelinRajapinta.class);
        proxy = new SokkelopeliProxy(target);
    }

    @Test(expected=ProxyException.class)
    public void shouldCheckForZeroReturnsForMazeWidth() {
        when(target.sokkelonLeveys()).thenReturn(0);
        proxy.sokkelonLeveys();
    }
    
    @Test(expected=ProxyException.class)
    public void shouldCheckForNegativeReturnsForMazeWidth() {
        when(target.sokkelonLeveys()).thenReturn(-3);
        proxy.sokkelonLeveys();
    }

    @Test(expected=ProxyException.class)
    public void shouldCheckForZeroReturnsForMazeHeight() {
        when(target.sokkelonKorkeus()).thenReturn(0);
        proxy.sokkelonKorkeus();
    }

    @Test(expected=ProxyException.class)
    public void shouldCheckForNegativeReturnsForMazeHeight() {
        when(target.sokkelonKorkeus()).thenReturn(-3);
        proxy.sokkelonKorkeus();
    }

    @Test(expected=ProxyException.class)
    public void shouldCheckForNullImageNameCollection() {
        Paikka p = new Paikka(0, 0);
        when(target.kuvaPaikassa(p)).thenReturn(null);
        proxy.kuvaPaikassa(p);
    }
}
