
package peli;

import org.junit.Test;
import static org.junit.Assert.*;

public class KarttaTest {

    private String esim1 =
        "#####\n" +
        "#....\n" +
        "##.##\n";

    @Test
    public void hyväksyyKunnollisenKartan() {
        String syote = esim1;
            
        Kartta kartta = Kartta.lueMerkkijonosta(syote);
        
        assertEquals(3, kartta.korkeus());
        assertEquals(5, kartta.leveys());
        assertEquals('#', kartta.merkkiKohdassa(0, 0));
        assertEquals('#', kartta.merkkiKohdassa(2, 4));
        assertEquals('.', kartta.merkkiKohdassa(1, 1));
        assertEquals('.', kartta.merkkiKohdassa(1, 4));
    }

    @Test(expected=IllegalArgumentException.class)
    public void hylkääTyhjänKartan() {
        Kartta.lueMerkkijonosta("");
    }

    @Test(expected=IllegalArgumentException.class)
    public void hylkääKartanJossaOnVainTyhjäRivi() {
        Kartta.lueMerkkijonosta("\n");
    }

    @Test(expected=IllegalArgumentException.class)
    public void hylkääKartanJossaRivienPituudetVaihtelevat() {
        Kartta.lueMerkkijonosta("#\n##");
    }

    @Test
    public void toStringPalauttaaKartanSamanlaisenaKuinSyötteessä() {
        String syote = esim1;
        Kartta kartta = Kartta.lueMerkkijonosta(syote);
        assertEquals(syote.toString().trim(), kartta.toString().trim());
    }
}
